# Definitions builtin for clearmake's Gnu-compatibility.
# Extracted from Gnu make by `gmake -p' and massaged a bit.

# Suffixes

SUFFIXES := .o .c .cc .cpp .C .s .S .y .l .out .a .ln .p .f .F .r .mod .sym .def .h .info .dvi .tex .texinfo .texi .txinfo .w .ch .web .sh .elc .el

.SUFFIXES:  .o .c .cc .cpp .C .s .S .y .l .out .a .ln .p .f .F .r .mod .sym .def .h .info .dvi .tex .texinfo .texi .txinfo .w .ch .web .sh .elc .el

# Avoid lexer problems.
# These get defined internally to clearmake anyway.
#
#@F = $(notdir $@)
#@D = $(patsubst %/,%,$(dir $@))
#+F = $(notdir $+)
#+D = $(patsubst %/,%,$(dir $+))
#%F = $(notdir $%)
#%D = $(patsubst %/,%,$(dir $%))
#?F = $(notdir $?)
#?D = $(patsubst %/,%,$(dir $?))
#<F = $(notdir $<)
#<D = $(patsubst %/,%,$(dir $<))
#*F = $(notdir $*)
#*D = $(patsubst %/,%,$(dir $*))
#^F = $(notdir $^)
#^D = $(patsubst %/,%,$(dir $^))

# Implicit Rules

# 1. Default non-suffix pattern rules

# Does this need work ?
#
(%): %
	$(AR) $(ARFLAGS) $@ $<

%.out: %
	@rm -f $@ 
	cp $< $@

%.c: %.w %.ch
	$(CTANGLE) $^ $@

%.tex: %.w %.ch
	$(CWEAVE) $^ $@

# 2. Default suffix  rules.

.o:
	$(LINK.o) $^ $(LOADLIBES) $(LDLIBS) -o $@

.s:
	$(LINK.s) $^ $(LOADLIBES) $(LDLIBS) -o $@

.S:
	$(LINK.S) $^ $(LOADLIBES) $(LDLIBS) -o $@

.c:
	$(LINK.c) $^ $(LOADLIBES) $(LDLIBS) -o $@

.cc:
	$(LINK.cc) $^ $(LOADLIBES) $(LDLIBS) -o $@

.cpp:
	$(LINK.cc) $^ $(LOADLIBES) $(LDLIBS) -o $@

.C:
	$(LINK.C) $^ $(LOADLIBES) $(LDLIBS) -o $@

.f:
	$(LINK.f) $^ $(LOADLIBES) $(LDLIBS) -o $@

.p:
	$(LINK.p) $^ $(LOADLIBES) $(LDLIBS) -o $@

.F:
	$(LINK.F) $^ $(LOADLIBES) $(LDLIBS) -o $@

.r:
	$(LINK.r) $^ $(LOADLIBES) $(LDLIBS) -o $@

.mod:
	$(COMPILE.mod) -o $@ -e $@ $^

.def.sym:
	$(COMPILE.def) -o $@ $<

.sh:
	cat $< >$@ 
	chmod a+x $@

.s.o:
	$(COMPILE.s) -o $@ $<

.S.o:
	$(COMPILE.S) -o $@ $<

.c.o:
	$(COMPILE.c) $< $(OUTPUT_OPTION)

.cc.o:
	$(COMPILE.cc) $< $(OUTPUT_OPTION)

.cpp.o:
	$(COMPILE.cc) $< $(OUTPUT_OPTION)

.C.o:
	$(COMPILE.C) $< $(OUTPUT_OPTION)

.f.o:
	$(COMPILE.f) $< $(OUTPUT_OPTION)

.p.o:
	$(COMPILE.p) $< $(OUTPUT_OPTION)

.F.o:
	$(COMPILE.F) $< $(OUTPUT_OPTION)

.r.o:
	$(COMPILE.r) $< $(OUTPUT_OPTION)

.mod.o:
	$(COMPILE.mod) -o $@ $<

.c.ln:
	$(LINT.c) -C$* $<

.y.ln:
	$(YACC.y) $< 
	$(LINT.c) -C$* y.tab.c 
	$(RM) y.tab.c

.l.ln:
	@$(RM) $*.c
	$(LEX.l) $< > $*.c
	$(LINT.c) -i $*.c -o $@
	$(RM) $*.c

.y.c:
	$(YACC.y) $< 
	mv -f y.tab.c $@

.l.c:
	@$(RM) $@ 
	$(LEX.l) $< > $@

.F.f:
	$(PREPROCESS.F) $< $(OUTPUT_OPTION)

.r.f:
	$(PREPROCESS.r) $< $(OUTPUT_OPTION)

.l.r:
	$(LEX.l) $< > $@ 
	mv -f lex.yy.r $@

.S.s:
	$(PREPROCESS.S) $< > $@

.texinfo.info:
	$(MAKEINFO) $(MAKEINFO_FLAGS) $< -o $@

.texi.info:
	$(MAKEINFO) $(MAKEINFO_FLAGS) $< -o $@

.txinfo.info:
	$(MAKEINFO) $(MAKEINFO_FLAGS) $< -o $@

.tex.dvi:
	$(TEX) $<

.texinfo.dvi:
	$(TEXI2DVI) $(TEXI2DVI_FLAGS) $<

.texi.dvi:
	$(TEXI2DVI) $(TEXI2DVI_FLAGS) $<

.txinfo.dvi:
	$(TEXI2DVI) $(TEXI2DVI_FLAGS) $<

.w.c:
	$(CTANGLE) $< - $@

.web.p:
	$(TANGLE) $<

.w.tex:
	$(CWEAVE) $< - $@

.web.tex:
	$(WEAVE) $<
